﻿# -*- coding: utf-8 -*-
# 2次元変数の緯度固定Ls指定してローカルタイムに沿った時間平均した図 (var-lon)
# mknc_dm1lst にも対応. localtime_mean にも対応.
$LOAD_PATH.push(Dir.pwd)
require "gphys_const"
require "numru/ggraph"
include NumRu

# 見たいデータファイルの相対パス
dir = '..'
#dir = '../analysis_Mars-2012-09-30/mknc_dm1lst-2012-09-22/out'

# PlanetLonFromVE.nc (Lsファイル) のある相対パス
ls_dir = '..'

# 重ね書きしたい地形データのある相対パス
#sp_dir = './tmp'
sp_dir = '.'

# 重ね書きしたい地形データ
sp_file = 'sp_for_Mars_T021_MGS'
#sp_file = 'dual_differential_topog'
#sp_file = 'differential_topog'
#sp_file = 'sp_for_Mars_T021_AvarageMGS'

# 重ね書きしたい地形の変数
sp_vname = 'topog'

# ファイルにつける語尾
#suffix = '_d2topdx2'
#suffix = '_dtopdx'
#suffix = 'top'
suffix = 'ogihara_script_top'
#suffix = 'ogihara_script_dtopdx'
#suffix = 'takahashi_script_top'

# 書きたい変数名
# 特別に diff_temp, diff_press, diff_pottemp はそれぞれ地表面(半整数レベルの最下層)と一層上の値(整数レベルの最下層)との差.
# pottemp_0 は地表面ポテンシャル温度, pottemp_1 は整数レベルの最下層, exner_0, exner_1 はそれぞれ地表面のエクスナー関数と整数レベルの最下層のエクスナー関数
#vnames = ['DDAF_d','SensB','Eta', 'Ps','SurfTemp']
#vnames = ['MOLength', 'BulkCoefHeat','SurfVelAbs']
vnames = ['DDAF_d', 'SensB', 'Eta']
#vnames = ['Ps', 'Temp', 'SurfTemp','Press_top']
#vnames = ['DDAF_d', 'SensB', 'Eta', 'Ps', 'diff_temp', 'SurfTemp','Press_top', 'diff_press']
#vnames = ['diff_pottemp','pottemp_0', 'pottemp_1', 'exner_0', 'exner_1']

# できた画像を格納するディレクトリ名
figdir = 'figs'
#Dir::mkdir( figdir )

# 初期にローカルタイム 0 時の経度
lon = [0]

# 見たい緯度
lat = [-25]
#lat = [-60, -50, -25,-15, 0, 15, 25, 50, 60]

# 見たいLs
ls = [270]
#ls = [0,45,90,110,180,210,270]

# 平均する日数
days = 5 

# 固定するローカルタイムの指定
#local_time = 12 # 固定するローカルタイムの時間
#unit = 'hour'   # 固定するローカルタイムの単位 (hour, sec, lon が選べる)
                # lon のときは太陽直下点の経度を直接与えられる
local_time = 190
unit = 'lon'

# 計算する年
iyrs = 5
iyre = 5

#ogihara_script_switch = false # true で荻原謹製ローカルタイム平均スクリプトを使用. false のままだと高橋さん謹製のスクリプト
ogihara_script_switch = true

#overwrite_topog_switch = false # true で地形高度を重ね書きする
overwrite_topog_switch = true


# 計算と書き出し
for ivar in 0..(vnames.length-1)
    
  for lat_num in 0..(lat.length-1)
    for ls_num in 0..(ls.length-1)
      for lon_num in 0..(lon.length-1)
        p 'vname: ' + vnames[ivar]
        p 'lat: ' + lat[lat_num].to_s
        p 'ls: ' + ls[ls_num].to_s
        p 'lon: ' + lon[lon_num].to_s

        system('ruby draw_2D_fit_lat_localtime_mean_log.rb ' + dir + ' ' + vnames[ivar] + ' ' + iyrs.to_s + ' ' + iyre.to_s + ' ' + lat[lat_num].to_s + ' ' + lon[lon_num].to_s + ' ' + ls[ls_num].to_s + ' ' + days.to_s + ' ' + local_time.to_s + ' ' + unit + ' ' + ls_dir + ' ' + overwrite_topog_switch.to_s + ' ' + ogihara_script_switch.to_s + ' ' + sp_dir + ' ' + sp_file + ' ' + sp_vname)

        system("pdftk dcl.pdf cat 1-endeast output kari")
        system("pdf2ps kari dcl.ps")
        #system("dclpsrmcm dcl.ps | dclpsrot | dclpsmargin > kari")
        system("dclpsrmcm dcl.ps | dclpsmargin > kari")
        system("mv kari dcl.ps")

        system("pstoimg -type gif dcl.ps")
        system("convert dcl.gif -trim dcl.gif")
        if /^-/ =~ lat[lat_num].to_s
          com = sprintf( "mv dcl.gif "+figdir+"/dcl_"+vnames[ivar]+'_fit_lat_m_' + lat[lat_num].to_s + 'ls' + ls[ls_num].to_s+suffix+'lt_mean_log.gif' )
        else
          com = sprintf( "mv dcl.gif "+figdir+"/dcl_"+vnames[ivar]+'_fit_lat' + lat[lat_num].to_s + 'ls' + ls[ls_num].to_s+suffix+'lt_mean_log.gif' )
        end
        system(com)
        com = sprintf( "mv dcl.ps  "+figdir+"/dcl_"+vnames[ivar]+'_fit_lat'+ lat[lat_num].to_s + 'ls' + ls[ls_num].to_s + suffix+'lt_mean_log.ps'  )
        system(com)
        system("rm dcl.pdf")
      end
    end
  end
end
