﻿# -*- coding: utf-8 -*-
$LOAD_PATH.push(Dir.pwd)
require "gphys_const"
require "gphys_methods"
require "gphys_time"
require "gphys_tmp_calc"
require "numru/ggraph"
include NumRu

dir  = ARGV[0]
dir2 = ARGV[1]
dir3 = ARGV[2]
vname = ARGV[3]
iyrs = ARGV[4].to_i
iyre = ARGV[5].to_i
lat = ARGV[6].to_i
lon = ARGV[7].to_i
ls = ARGV[8].to_i
days = ARGV[9].to_i
non_observation_switch = ARGV[10].to_s

if non_observation_switch == 'true'
  non_observation_switch = true
else
  non_observation_switch = false
end

time_array = ls_to_time(iyrs, iyre, dir, [ls])
lt_array = local_starting_time_and_ending_time(time_array[0],days, lon, dir)
#title = MonNames[imon-1]
p dir
p dir2
p dir3

gphys = GPhys::NetCDF_IO.open(dir+'/'+vname+".nc", vname)
gphys2 = GPhys::NetCDF_IO.open(dir2+'/'+vname+".nc", vname)
gphys3 = GPhys::NetCDF_IO.open(dir3+'/'+vname+".nc", vname)

#temp = diff_temp_surftemp(dir,lt_array[0],lt_array[1],lat,lon)
#temp2 = diff_temp_surftemp(dir2,lt_array[0],lt_array[1],lat,lon)
#< DCLのオープンと設定 >
DCL.gropn(2)
#DCL.sldiv('y',2,2)           # 2x2に画面分割, 'y'=yoko: 左上→右上→左下...
DCL.sgpset('lcntl', false)   # 制御文字を解釈しない
#DCL.sgpset('lfull',true)     # 全画面表示
DCL.uzfact(0.75)             # 座標軸の文字列サイズを 0.75 倍
DCL.sgpset('lfprop',true)    # プロポーショナルフォントを使う
DCL.uzlset('LOFFSET',true)   # 次の XOFFSET で軸の値のオフセットを取れるようにする
DCL.uzrset('XOFFSET',- gphys.cut("time"=>lt_array[0]..lt_array[1]).coord("time").val[0].to_i) # 計算はじめの時間でオフセットを取り, 座標軸を0-24 に合わせる

#< GGraph による 描画 >
#GGraph.set_fig 'itr'=>10, 'viewport'=>[0.15,0.85,0.1,0.6], 'window'=>[0,360,-90,90]
#GGraph.set_fig 'viewport'=>[0.15,0.85,0.1,0.6], 'window'=>[0,360,-90,90]
#GGraph.set_map 'coast_world'=>true, 'grid'=>false
#GGraph.set_axes('yside'=>'lr','xside'=>'tb')
#GGraph.set_axes('ylabelint'=>15)
#GGraph.set_axes('xtickint'=>4,'xlabelint'=>24)
GGraph.set_axes('xside'=>'t','xtickint'=>1,'xlabelint'=>4)



#if vname == 'DDAF_d'
#  if lat == -25 || lat == -30
#    vmax = 80.0*10**(-12)
#  else
#  vmax = 60.0*10**(-12)
#  end
#  vmin = 0.0
#elsif vname == 'Sens'
#  if lat == -25 || lat == -30
#    vmax = 13
#  else
#  vmax = 10.4
#  end
#  vmin = 1.0
#elsif vname == 'Eta'
#  vmax = 26 * 0.001
#  vmin = 0.0
#end
if vname == 'DDAF_d'
  if lat == -25 then
  vmax = 40.0*10**(-11)
  vmin = 0.0
  elsif lat == 25
    vmax = 24.0 *10**(-11)
    vmin = 0.0
  end
elsif vname == 'Sens'
  if lat == -25
  vmax = 60
  vmin = -5
  elsif lat == 25
    vmax = 40
    vmin = -5
  end
elsif vname == 'Eta'
  if lat == -25
  vmax = 0.1
  vmin = 0.0
  elsif lat == 25
    vmax = 0.09
    vmin = 0.0
  end
elsif vname == 'Ps'
  if lat == -25
    vmax = 520
    vmin = 690
  elsif lat == 25
    vmax = 620
    vmin = 710
  end
elsif vname == 'Press_top'
  #vmax = 200
  vmax = 300
  vmin = 700
elsif vname == 'k_top'
  vmax = 20
elsif vname == 'Temp'
  if lat == -25
  vmax = 44
  vmin = nil
  elsif lat == 25
    vmax = 36
    vmin = -8
  end
else
  vmax = nil
  vmin = nil
end

# 作図
#GGraph.line(gphyscal,true, 'index'=>21, 'max'=> vmax, 'min'=> vmin, 'annotate'=>false)
#GGraph.line(gphyscal2,false, 'index'=>11, 'max'=> vmax, 'min'=> vmin, 'annotate'=>false)
#GGraph.line(gphyscal3,false, 'index'=>41, 'max'=> vmax, 'min'=> vmin, 'annotate'=>false)

# 地表面との温度差を求める場合
#ggraph_line_difftemp(temp, temp2)
# 時間を直接入力で求める場合
#ggraph_line_lt_input(gphys, gphys2, 52896, 52920,lat,lon,vmax, vmin)
#ggraph_line_lt_input(gphys, gphys2, 60528, 60552,lat,lon,vmax, vmin)

GGraph.line(gphys.cut("time"=>lt_array[0]..lt_array[1],"lat"=>lat, "lon"=>lon),true, 'index'=>21, 'type'=>1, 'max'=> vmax, 'min'=> vmin, 'annotate'=>false, 'legend'=>'flat')
GGraph.line(gphys2.cut("time"=>lt_array[0]..lt_array[1],"lat"=>lat, "lon"=>lon),false, 'index'=>41, 'type'=>1, 'max'=> vmax, 'min'=> vmin, 'annotate'=>false, 'legend'=>'zonal mean')
unless non_observation_switch
  GGraph.line(gphys3.cut("time"=>lt_array[0]..lt_array[1],"lat"=>lat, "lon"=>lon),false, 'index'=>11, 'type'=>1, 'max'=> vmax, 'min'=> vmin, 'annotate'=>false, 'legend'=>'observation')
end

##GGraph.line(gphys.cut("time"=>60600..60720,"lat"=>lat, "lon"=>0),true, 'index'=>21, 'type'=>1, 'max'=> vmax, 'min'=> vmin, 'annotate'=>false, 'legend'=>'flat')
##GGraph.line(gphys2.cut("time"=>60600..60720,"lat"=>lat, "lon"=>0),false, 'index'=>11, 'type'=>1, 'max'=> vmax, 'min'=> vmin, 'annotate'=>false, 'legend'=>'observation')
##GGraph.line(gphys3.cut("time"=>60600..60720,"lat"=>lat, "lon"=>0),false, 'index'=>41, 'type'=>1, 'max'=> vmax, 'min'=> vmin, 'annotate'=>false, 'legend'=>'zonal mean')
#
#GGraph.line(gphys.cut("time"=>52824..52944,"lat"=>lat, "lon"=>0),true, 'index'=>21, 'type'=>1, 'max'=> vmax, 'min'=> vmin, 'annotate'=>false, 'legend'=>'flat')
##GGraph.line(gphys2.cut("time"=>52824..52944,"lat"=>lat, "lon"=>0),false, 'index'=>11, 'type'=>1, 'max'=> vmax, 'min'=> vmin, 'annotate'=>false, 'legend'=>'observation')
#GGraph.line(gphys3.cut("time"=>52824..52944,"lat"=>lat, "lon"=>0),false, 'index'=>41, 'type'=>1, 'max'=> vmax, 'min'=> vmin, 'annotate'=>false, 'legend'=>'zonal mean')
##GGraph.line(gphys.cut("time"=>52824..52944,"lat"=>lat, "lon"=>0)[false,0,true],true, 'index'=>21, 'type'=>1, 'max'=> vmax, 'min'=> vmin, 'annotate'=>false, 'legend'=>'flat')
##GGraph.line(gphys2.cut("time"=>52824..52944,"lat"=>lat, "lon"=>0),false, 'index'=>11, 'type'=>1, 'max'=> vmax, 'min'=> vmin, 'annotate'=>false, 'legend'=>'observation')
##GGraph.line(gphys3.cut("time"=>52824..52944,"lat"=>lat, "lon"=>0)[false,0,true],false, 'index'=>41, 'type'=>1, 'max'=> vmax, 'min'=> vmin, 'annotate'=>false, 'legend'=>'zonal mean')

# 上下の座標軸を書く
DCL::uxaxdv('T',1,4)
DCL::uxaxdv('B',1,4)

# タイトルの指定
DCL::uxmttl('T', ' ', 1.0)

#DCL::uxmttl('T', title, -1.0)


DCL::grcls
if File.exists?('./sagyou.nc') then
  File.delete('./sagyou.nc')
end
