﻿# -*- coding: utf-8 -*-
$LOAD_PATH.push(Dir.pwd)
require "gphys_const"
require "gphys_methods"
require "gphys_time"
require "numru/ggraph"
include NumRu

dir  = ARGV[0]
vname = ARGV[1]
iyrs = ARGV[2].to_i
iyre = ARGV[3].to_i
alt_value_switch = ARGV[4].dup
if alt_value_switch == "true" then
  alt_value_switch = true
else
  alt_value_switch = false
end
if alt_value_switch then
  alt = ARGV[5].to_f
else
  alt = ARGV[5].to_i
end
#solswitch = ARGV[4].dup
#colorswitch = ARGV[5].dup
#logswitch = ARGV[6].dup

#if solswitch == "true" then
#  solswitch = true
#else
#  solswitch = false
#end
#if colorswitch == "true" then
#  colorswitch = true
#else
#  colorswitch = false
#end
#if logswitch == "true" then
#  logswitch = true
#else
#  logswitch = false
#end
#title = MonNames[imon-1]

gphys = GPhys::NetCDF_IO.open(dir+'/'+vname+".nc", vname)

if vname == 'OMG'
  DCL.sgscmn(14) #blue-white-red
end

#< DCLのオープンと設定 >
DCL.gropn(2)
#DCL.sldiv('y',2,2)           # 2x2に画面分割, 'y'=yoko: 左上→右上→左下...
DCL.sgpset('lcntl', false)   # 制御文字を解釈しない
DCL.sgpset('lfull',true)     # 全画面表示
DCL.uzfact(0.75)             # 座標軸の文字列サイズを 0.75 倍
DCL.sgpset('lfprop',true)    # プロポーショナルフォントを使う

#< GGraph による 描画 >
#GGraph.set_fig 'itr'=>10, 'viewport'=>[0.15,0.85,0.1,0.6], 'window'=>[0,360,-90,90]
GGraph.set_fig 'viewport'=>[0.15,0.85,0.1,0.6], 'window'=>[0,360,-90,90]
#GGraph.set_map 'coast_world'=>true, 'grid'=>false
GGraph.set_axes('yside'=>'lr','xside'=>'tb')
GGraph.set_axes('xlabelint'=>100)
GGraph.set_axes('ylabelint'=>15)
#GGraph.set_axes('xlabelint'=>90)
#GGraph.set_axes('ylabelint'=>30)


if alt_value_switch then
  gphysout = zonal_mean_3D_with_value( dir, iyrs, iyre, alt, gphys)
  if gphys.coord(-2).name == 'level'
    title = 'level =' + alt.to_s + gphys.coord(-2).units.to_s
  elsif gphys.coord(-2).name == 'sig'
    title = 'sig =' + alt.to_s
  elsif gphys.coord(-2).name == 'sigm'
    title = 'sig =' + alt.to_s
  end
else
p  gphys.axis(-2)[alt]
  gphysout = zonal_mean_3D_with_layer( dir, iyrs, iyre, alt, gphys)
  if gphys.coord(-2).name == 'level'
    title = 'level =' + gphys.coord(-2)[alt].val[0].to_s + gphys.coord(-2).units.to_s
  elsif gphys.coord(-2).name == 'sig'
    title = 'sig =' + gphys.coord(-2)[alt].val[0].to_s
  elsif gphys.coord(-2).name == 'sigm'
    title = 'sig =' + gphys.coord(-2)[alt].val[0].to_s
  end
end

#if (vname == 'KMHF_d' || vname == 'DDAF_d') && solswitch then
#  gphysout = calc_sol(gphysout.mean(0))
#  p "kotti"
#end

# レベル＆パターンを陽に指定
# パタンの方が1つ多→±∞ まで

if vname == 'OMG'
  #levels = ['-3.0* 10**(-4)','-2.625*10**(-4)',  '-2.25* 10**(-4)','-1.825 * 10**(-4)', '-1.5* 10**(-4)','-1.125*10**(-4)',  '-0.75* 10**(-4)', '-0.375* 10**(-4)','0.0','0.375*10**(-4)', '0.75* 10**(-4)', '1.125*10**(-4)', '1.5* 10**(-4)', '1.825 * 10**(-4)',  '2.25* 10**(-4)', '2.625*10**(-4)', '3.0* 10**(-4)']
  #patterns = ['10999', '15999', '20999', '25999', '30999', '35999', '40999', '45999', '50999', '55999','60999', '65999', '70999', '75999', '80999', '85999', '90999', '95999']
  #patterns = ['10999', '20999', '30999', '35999', '40999', '50999', '60999', '70999', '75999', '80999', '85999', '90999']
  #levels = [ '-3.75 * 10**(-4)',  '-3.0* 10**(-4)',  '-2.25* 10**(-4)', '-1.5* 10**(-4)',  '-0.75* 10**(-4)', '0.0', '0.75* 10**(-4)',  '1.5* 10**(-4)', '2.25* 10**(-4)', '3.0* 10**(-4)' '3.75* 10**(-4)']
  #patterns = ['10999', '20999', '30999', '35999', '40999', '50999', '60999', '70999', '75999', '80999', '85999', '90999']
  #patterns = ['10999', '20999', '30999', '35999', '40999', '50999', '60999', '70999', '75999', '80999', '90999']
  #低速を細かく
  #levels = ['-0.400e-3 ', '-0.350e-3', '-0.300e-3', '-0.250e-3', '-0.200e-3', '-0.150e-3', '-0.100e-3', '-0.050e-3', '0.0', '0.050e-3', '0.100e-3','0.150e-3', '0.200e-3', '0.250e-3', '0.300e-3', '0.350e-3', '0.400e-3']
  #patterns = ['10999', '15999', '20999', '25999', '30999', '35999', '40999', '45999', '50999', '55999','60999', '65999', '70999', '75999', '80999', '85999', '90999', '95999']
  #もう少し高速を細かく
  levels = ['-1.20e-3 ', '-1.050e-3', '-0.90e-3', '-0.750e-3', '-0.600e-3', '-0.450e-3', '-0.300e-3', '-0.150e-3', '0.0', '0.150e-3', '0.300e-3','0.450e-3', '0.600e-3', '0.750e-3', '0.900e-3', '1.050e-3', '1.200e-3']
  patterns = ['10999', '15999', '20999', '25999', '30999', '35999', '40999', '45999', '50999', '55999','60999', '65999', '70999', '75999', '80999', '85999', '90999', '95999']
end


#GGraph.tone_and_contour(gphysout,true,'exchange'=>true)
GGraph.tone(gphysout, true, 'lev'=>levels, 'pat'=>patterns,'map_axes'=>true, 'annotate'=>false,'exchange'=>true)
#GGraph.tone_and_contour(gphysout, true, 'lev'=>levels, 'pat'=>patterns, 'map_axes'=>true, 'annotate'=>false, 'exchange'=>true)
#GGraph.tone_and_contour(gphysout, true, 'map_axes'=>true, 'annotate'=>false, 'exchange'=>true)
GGraph.color_bar

#if logswitch then
#  GGraph.color_bar('constwidth'=>true, 'labelintv'=>1)
#else
#  GGraph.color_bar
#end
#if vname == 'KMHF_d' or vname == 'NewmanF_d' or vname == 'Ps' or vname == 'Tau',
  ice = GPhys::NetCDF_IO.open('../SurfMajCompIce.nc', 'SurfMajCompIce')
  iceout = maketime( dir, iyrs, iyre, ice).mean(0)
#  iceout = iceout * (-1)
#  DCL.uepset('LTONE',false)
#  tlev1 = 10.0
#  tlev2 = DCL.glpget('RMISS')

  #levels = [0,1.0e-1, 1, 100,200, 300,400,500,600,700, 800, 900, 940]
  levels = [1]
#p tlev2
#  DCL::uestlv(tlev1,tlev2,301)
#GGraph.contour(iceout,false,'levels'=>levels,'line_type'=>2,'label'=>false,'exchange'=>true)
GGraph.contour(iceout,false,'levels'=>levels,'index'=>9,'label'=>false,'exchange'=>true)
#  DCL::uetone(iceout.val)
#  DCL::udcntr(iceout.val) 

#GGraph.tone(iceout,false,'ltone'=>false)
  DCL::ueitlv
#end

#DCL::uxmttl('T', ' ', 1.0)
DCL::uxmttl('T', title, -1.0)


DCL.grcls
if File.exists?('./sagyou.nc') then
  File.delete('./sagyou.nc')
end

