!
!火星の地形を東西方向の勾配とるスクリプト
! 1/cos\varphi \DD{topog}{\lambda}
program dtopdx
!  use ee_module
  use w_module
  use dc_types, only: DP
  use gtool_history
  implicit none

  integer, parameter :: im=64, jm=32
  integer, parameter :: nm=21
  integer, parameter :: km=64, lm =32

  real(8), parameter :: pi = 3.141591653589793

  real(DP) :: xy_Topog(0:im-1, 1:jm)
  real(DP) :: dx_Topog(0:im-1,1:jm)
  real(DP) :: w_Topog((nm + 1)*(nm + 1))
  !  real(DP) :: x_lon(0:im-1)
  !  real(DP) :: y_lat(1:jm)

  write(*,*)"test1"
  call HistoryGet('../sp_for_Mars_T021_MGS.nc', 'topog', xy_Topog)
  !call HistoryGet('../sp_for_Mars_T021_MGS.nc', 'lon', x_lon)
  !call HistoryGet('../sp_for_Mars_T021_MGS.nc', 'lat', y_lat)
  
  call w_Initial(nm,im,jm)
  write(*,*) "test2"
  dx_Topog=xy_GradLon_w(w_xy(xy_Topog))
  write(*,*) "test3"
  call HistoryCreate( &
    & file='../tmp/differential_topog.nc', title='differential calculate Topog', &
    & source='SPMODEL', &
    & institution='', &
    & dims=(/'lon','lat'/), dimsizes=(/im,jm/),&
    & longnames=(/'longitude','latitude '/), &
    & units=(/'deg', 'deg'/), &
    & origin=0.0, interval=3700.0)
  write(*,*)"test4"
  call HistoryPut('lon',x_Lon*180/pi)
  write(*,*)"test5"
  call HistoryPut('lat',y_Lat*180/pi)
  write(*,*)"test6"

  call HistoryAddVariable( &
    & varname='topog', dims=(/'lon','lat'/), &
    & longname='differential calculated topography', &
    & units='m', &
    & xtype='double')

  write(*,*)"test6"
  call HistoryPut('topog',dx_Topog)
  write(*,*)"test7"
  call HistoryClose
end program dtopdx
