#!/bin/bash

RUBY=ruby
SRC=olr-horizontal_v.rb
#SRC=trnsprt_t.rb
CONVERT="convert -rotate 90"

OUTFILE_FOOT=`basename ${SRC} .rb`

WSN=2

LON_CNT=270

FACT_MEAN=0.0001      # (u,v)
#FACT_MEAN=0.1      # Qu
#FACT_MEAN=0.000005   # Tu

#UNIT_MEAN=0.03    # Qu
UNIT_MEAN=100    # Qu
#UNIT_MEAN=1e4   # Tu

#omegas="0.0 0.15 0.5 1.0"
omegas="0.15"

#omegas="0.0 0.05 0.1 0.15 0.2 0.25 0.33 0.4 0.5 0.6 0.67 0.8 1.0"
#omegas="0.5"


### mean
for omega in ${omegas}; do
    ${RUBY} ${SRC} \
	--omega ${omega} \
	--xfact1 ${FACT_MEAN} --yfact1 ${FACT_MEAN} \
	--uxunit ${UNIT_MEAN} --uyunit ${UNIT_MEAN} \
        --loncnt ${LON_CNT} \
	--wsn ${WSN}
    if [ -e dcl.ps ]; then
	name=Omega${omega}_${OUTFILE_FOOT}_${LON_CNT}all
#	${CONVERT} dcl.ps Omega${omega}_${OUTFILE_FOOT}_all.eps
#	dclpsrmcm dcl.ps | dclpsrot | dclpsmargin > ${name}.eps
#	dclpsrot dcl.ps | dclpsmargin > ${name}.ps
        mv dcl.ps ${name}.ps
	ps2png.rb ${name}.ps
    fi
    rm -f dcl.ps
done

rm -f dcl.ps
