#! /usr/bin/env ruby
# -*- coding: utf-8 -*-

require "yaml"
require "numru/ggraph"
include NumRu

CONFIGFILE = "./config.yml"

DATA_HOME = "/GFD_Dennou_Work3/momoko/SyncRotEarthRad"
DIR_HEADER = "SR_Omega"
DIR_FOOTER = "_dt20m"

CONFIG = YAML.load( File.read(File.join(File.dirname(__FILE__), CONFIGFILE)) )
#CONFIG = YAML.load( File.read( CONFIGFILE ) )




def omegas
  CONFIG["omegas"]
end

def nomega
  omegas.size
end

def exp_dirs
  exp_dirs = Hash.new
  omegas.each{|omega|
    exp_dirs[omega] = File.join(DATA_HOME, DIR_HEADER + omega.to_s + DIR_FOOTER)
  }
  exp_dirs
end


# gphys
def axis_omega
  va_omega = VArray.new( NArray.to_na(omegas),
#                    {"long_name"=>"Omega scaled by the Earth's value","units"=> "1"},
                         {
                           "long_name"=>CONFIG["omega_long_name"],
                           "units"=>CONFIG["omega_units"].to_s
                         },
                         CONFIG["omega_name"] 
                         )
  axis_omega = Axis.new.set_pos(va_omega)
end



# ----- all ---------------------------

def omegas_all
  CONFIG["omegas_all"]
end

def exp_all_dirs
  exp_all_dirs = Hash.new
  omegas.each{|omega|
    exp_all_dirs[omega] = File.join(DATA_HOME, DIR_HEADER + omega.to_s + DIR_FOOTER)
  }
  exp_all_dirs
end
