#! /usr/bin/ruby
# -*- coding: utf-8 -*-



# dc-thumb.rb を
# 雛型となる thum.txt を読み込んで画像ファイル名の置換を
# おこなう.
# 画像ファイル名は (実験名)_(物理量と説明).[png, gif]
# という形式であるとする.
# thum.txt を作成するディレクトリ (thum-src/ ディレクトリ) で実行する.
# ディレクトリ構造として, (実験名)/thum-src/ となっていることを仮定する.
# ファイル名中の最初のアンダースコアの前の部分を 1 つ上のディレクトリ名
# (実験名と同じものになっていることを仮定)
# で置き換える

#== オプション
#   無し

#== 実行方法
#   % make-thum-txt.rb

#== 参考文献・URL
# * http://d.hatena.ne.jp/jun-yoshida/20060825/1156463224

# 履歴
# * 2013-07-16 石渡 作成

# テンプレートファイルの指定. 適宜, ここを書き換えること.
#template_file = "/GFD_Dennou_Work3/momoko/LandPlanet/2013-07-13_momoko/L_Omega1.0_I23.44/thum-src/thum.txt"
template_file = "/GFD_Dennou_Work3/momoko/SyncRotEarthRad/2013-06-19_momoko/SR_Omega0.0/thum-src/thum.txt"

# テンプレートファイル中で指定されいる実験名. 適宜, ここも書き換えること.
#template_exp_name = "L_Omega1.0_I23.44"
template_exp_name = "SR_Omega0.0"

# 出力ファイル名
output_file = "thum.txt"

# 実験名 (1 つ上のディレクトリ名) の取得
exp_name = Dir::pwd.split("/")[-2]

p exp_name

open(template_file){ |f|
  open(output_file,"w"){ |o|
    while line = f.gets
      line.gsub!(template_exp_name,exp_name)
      o.puts line
      end
  }
}


