﻿# coding: utf-8
#2013/1/7 荻原 calc_sol 追加 gphys_methods_v1.4
#2013/12/22 荻原 nan_to_rmiss 追加 gphys_methods_v1.5
#2014/11/20 荻原 msf.nc 作成用メソッド追加. calc_msf_core が参考. gphys_methods_v1.6
$LOAD_PATH.push(Dir.pwd)
require 'gphys_const'
require "numru/ggraph"
include NumRu
include NMath

#########################################################################################

def ecmwf_clim_mean_with_mon_mean( iyrs, iyre, imon, gphys )

  time = gphys.coord('time').val

  for iyr in iyrs..iyre
    t = ( iyr - 1957 ) * 12 + imon - ( 9 - 1 )

    if iyr == iyrs
      gphysout = gphys.cut('time'=>time[t])
    else
      gphysout = gphysout + gphys.cut('time'=>time[t])
    end
  end
  gphysout = gphysout / ( iyre - iyrs + 1 )

  return gphysout

end

#########################################################################################

def ncep_clim_mean_with_mon_mean( iyrs, iyre, imon, gphys )

  time = gphys.coord('time').val

  for iyr in iyrs..iyre
    t = ( iyr - 1948 ) * 12 + imon - 1

    if iyr == iyrs
      gphysout = gphys.cut('time'=>time[t])
    else
      gphysout = gphysout + gphys.cut('time'=>time[t])
    end
  end
  gphysout = gphysout / ( iyre - iyrs + 1 )

  return gphysout

end

#########################################################################################

def dcpam_clim_mon_mean( iyrs, iyre, imon, gphys )

  daysOfYear = 0
  DaysOfMonth.each do |i|
    daysOfYear += i
  end

  time = gphys.coord('time').val
  for iyr in iyrs..iyre
    t = daysOfYear*(iyr-1)
    for i in 1..imon-1
      t = t + DaysOfMonth[i-1]
    end

    ts = t
    te = t + DaysOfMonth[imon-1]
    ts = ts * DataNumOfDay
    te = te * DataNumOfDay - 1
#    if iyr == iyrs
#      gphysout = gphys.cut('time'=>time[ts]..time[te]).mean('time')
#    else
#      gphysout = gphysout + gphys.cut('time'=>time[ts]..time[te]).mean('time')
#    end


#    gphysout1 = gphys.cut('time'=>time[ts]).copy
#    for t in ts+1..te
#      gphysout1 = gphysout1 + gphys.cut('time'=>time[t])
#    end
#    gphysout1 = gphysout1 / ( te - ts + 1 )
#    if iyr == iyrs
#      gphysout = gphysout1
#    else
#      gphysout = gphysout + gphysout1
#    end

### 月の途中から描きたい場合はここのコメントアウトを外す. 初めから描く場合はコメントアウトする
#    time = time.to_a
#    tsize = ts + time.size
#
#    while time.size < tsize
#    time.unshift(0)
#    end
#    time = NArray.to_na(time)
#    p "hajime=", time[ts]
####
    
#    gphysout1 = gphys.cut('time'=>time[ts]).copy
    gphysout1 = gphys.cut('time'=>ts).copy
#    dt = 1
    dt = ( te - ts + 1 ) / 3
#    dt = te - ts + 1
    t1 = ts
    t2 = ts
    while true
      t1 = t2+1
      t2 = t1+dt-1
      if t2 >= te then
        break
      end
      gphysout1 = gphysout1 + gphys.cut('time'=>t1..t2).sum('time')
#      gphysout1 = gphysout1 + gphys.cut('time'=>time[t1]..time[t2]).sum('time')
    end
    t2 = te
#    gphysout1 = gphysout1 + gphys.cut('time'=>time[t1]..time[t2]).sum('time')
    gphysout1 = gphysout1 + gphys.cut('time'=>t1..t2).sum('time')
    gphysout1 = gphysout1 / ( te - ts + 1 )
    if iyr == iyrs
      gphysout = gphysout1
    else
      gphysout = gphysout + gphysout1
    end


  end
  gphysout = gphysout / ( iyre - iyrs + 1 )

  return gphysout

##    gphysout1 = gphys.cut('time'=>ts).copy
###    dt = 1
##    dt = ( te - ts + 1 ) / 3
###    dt = te - ts + 1
##    t1 = ts
##    t2 = ts
##    while true
##      t1 = t2+1
##      t2 = t1+dt-1
##      if t2 >= te then
##        break
##      end
##      gphysout1 = gphysout1 + gphys.cut('time'=>t1..t2).sum('time')
##    end
##    t2 = te
##    gphysout1 = gphysout1 + gphys.cut('time'=>t1..t2).sum('time')
##    gphysout1 = gphysout1 / ( te - ts + 1 )
##    if iyr == iyrs
##      gphysout = gphysout1
##    else
##      gphysout = gphysout + gphysout1
##    end
##
##
##  end
##  gphysout = gphysout / ( iyre - iyrs + 1 )
##
##  return gphysout
end

#########################################################################################

def calc_msf( gphys )

gphysout = calc_msf_core( gphys, 'lat', 'level' )

return gphysout

end

#########################################################################################

def calc_msf_core( gphys, namelat, namelev )

rmiss = gphys.get_att('missing_value')[0]

gphyscopied = gphys.copy

z = gphyscopied.axis(namelev).pos.convert_units( Units['Pa'] )
z.long_name = 'pressure'
gphyscopied.axis(namelev).set_pos(z)

km    = gphyscopied.shape[1]
lat   = gphyscopied.coord(namelat).val
level = gphyscopied.coord(namelev).val


gphysout = gphyscopied.copy


#mask                  = gphyscopied.ne(rmiss)
#gphyscopied[mask.not] = 0.0

#mask        = gphyscopied.val.valid?
mask        = gphyscopied.val.get_mask
gphyscopied = gphyscopied.val.set_missing_value(0.0).all_valid


if level[0] > level[1] then
  gphysout[true,km-1] = gphyscopied[true,km-1] * level[km-1] / Grav * 2 * PI * RPlanet * cos( lat[true] * PI / 180.0 )
  k = km-1-1
  while k >= 0
    gphysout[true,k] = gphysout[true,k+1] + ( gphyscopied[true,k] + gphyscopied[true,k+1] ) * 0.5 * ( level[k] - level[k+1] ) / Grav * 2 * PI * RPlanet * cos( lat[true] * PI / 180.0 )
  k -= 1
  end
elsif
  gphysout[true,0] = gphyscopied[true,0] * level[0] / Grav * 2 * PI * RPlanet * cos( lat[true] * PI / 180.0 )
  k = 0+1
  while k < km
    gphysout[true,k] = gphysout[true,k-1] + ( gphyscopied[true,k] + gphyscopied[true,k-1] ) * 0.5 * ( level[k] - level[k-1] ) / Grav * 2 * PI * RPlanet * cos( lat[true] * PI / 180.0 )
  k += 1
  end
end

gphysoutNaMiss = gphysout.val.set_mask(mask)
gphysout[true,true] = gphysoutNaMiss[true,true]

gphysout = gphysout * 1.0e-8

gphysout.long_name = 'mass stream function'
gphysout.units     = '1e8 kg/s'

return gphysout

end

#########################################################################################

def calc_angmom( gphys )

gphysout = calc_angmom_core( gphys, 'lat', 'level' )

return gphysout

end

#########################################################################################

def calc_angmom_core( gphys, namelat, namelev )

rmiss = gphys.get_att('missing_value')[0]

gphyscopied = gphys.copy

z = gphyscopied.axis(namelev).pos.convert_units( Units['Pa'] )
z.long_name = 'pressure'
gphyscopied.axis(namelev).set_pos(z)

#mask                  = gphyscopied.ne(rmiss)
#gphyscopied[mask.not] = rmiss #0.0

mask = gphyscopied.val.get_mask

jm    = gphyscopied.shape[0]
km    = gphyscopied.shape[1]
lat   = gphyscopied.coord(namelat).val
level = gphyscopied.coord(namelev).val

gphysout = gphyscopied.copy


k = 0
while k < km
  j = 0
  while j < jm
    if mask[j,k] == 1 then
      gphysout[j,k] = ( RPlanet * cos( lat[j] * PI / 180.0 ) * Omega + gphysout.val[j,k] ) * RPlanet * cos( lat[j] * PI / 180.0 )
    end
    j = j + 1
  end
  k = k + 1
end

gphysout = gphysout * 1.0e-8

gphysout.long_name = 'angular momentum'
gphysout.units     = '1e8 m2 s-1'

return gphysout

end

#########################################################################################

def calc_qsat_tetens( gphys )

gphysout = gphys.copy

z = gphysout.axis('level').pos.convert_units( Units['Pa'] )
z.long_name = 'pressure'
gphysout.axis('level').set_pos(z)

km    = gphysout.shape[2]
level = gphysout.coord('level').val


gasRUniv   = 8.314
molWtDry   = 28.964e-3
molWtWet   = 18.01528e-3
es0        = 611.0
latentHeat = 2.5e6
gasRWet    = gasRUniv / molWtWet
epsV       = molWtWet / molWtDry

gphysout = epsV * es0 * ( latentHeat / gasRWet * ( 1.0/273.0 - 1.0/gphysout ) ).exp

k = 0
while k < km
  gphysout[true,true,k,true] = gphysout[true,true,k,true] / level[k]
  k += 1
end

gphysout.long_name = 'saturation specific humidity'
gphysout.units     = '1'

return gphysout

end

#########################################################################################

def calc_sol(gphys)

sol = HoursOfSecond * DataNumOfDay
gphyssol = gphys * sol

return gphyssol

end
def nan_to_rmiss(gphys, rmiss)
  dimnum = gphys.rank
  sagyoufile = NetCDF.create('sagyou.nc')
  for num in 0..(dimnum - 1)
    dim = gphys.coord(num)
    sagyoufile.def_dim(dim.name, dim.length)
  end
  for num in 0..(dimnum-2)  #緯度, 経度, 高さまでの定義
    sagyoufile.redef
    dim = gphys.coord(num)
    sagyou = sagyoufile.def_var(dim.name, dim.ntype, [dim.name])
    for i in 0..(dim.att_names.size - 1)
      sagyou.put_att(dim.att_names[i], dim.get_att(dim.att_names[i]))
    end
    sagyoufile.enddef
    sagyou.put(dim.val)
  end
  sagyoufile.redef
  time = sagyoufile.def_var(gphys.coord(-1).name, gphys.coord(-1).ntype, [gphys.coord(-1).name])
  for i in 0..(gphys.coord(-1).att_names.size - 1)
    time.put_att(gphys.coord(-1).att_names[i], gphys.coord(-1).get_att(gphys.coord(-1).att_names[i]))
  end
  timecount = gphys.coord(-1).val
  sagyou = sagyoufile.def_var(gphys.name, gphys.ntype, gphys.axnames)
  for i in 0..(gphys.att_names.size - 1)
    sagyou.put_att(gphys.att_names[i], gphys.get_att(gphys.att_names[i]))
  end
  sagyoufile.enddef
  index=0
  time = sagyoufile.var(gphys.axnames[-1])
  axnames = gphys.shape.size - 1
  array1 = Array.new(axnames, 0)
  array2 = Array.new(axnames,0)
#  p gphys.shape
#  p dimnum
#  p rmiss
#  p gphys[0,0,-1,0].val[0].nan?
  timecount.each do |times|
    array1.fill(0,0..-1).push(index)
    array2.fill(-1,0..-1).push(index)
#    p "test"
    if dimnum == 4 then
      gphysdata = NArray.sfloat(gphys.shape[0], gphys.shape[1], gphys.shape[2])
#      p gphysdata
      for k in 0..(gphys.shape[2] - 1)
	for j in 0..(gphys.shape[1] - 1)
	  for i in 0..(gphys.shape[0] - 1)
#	    p "koti"
#	    p gphys[i,j,k,index].val
#	    p gphys[i,j,k,index].val[0].nan?
	    if gphys[i,j,k,index].val[0].nan? then
#	      p times
#	      p i
#	      p j
#	      p k
	      gphysdata[i,j,k] = rmiss
	    else
#	      p times
#	      p i
#	      p j
#	      p k
	      gphysdata[i,j,k] = gphys[i,j,k,index].val[0]
	    end
	  end
	end
      end
    elsif dimnum == 3 then
#      p gphysdata
      gphysdata = NArray.sfloat(gphys.shape[0], gphys.shape[1])
      for j in 0..(gphys.shape[1] - 1)
	for i in 0..(gphys.shape[0] - 1)
	  if gphys[i,j,index].val[0].nan? then
	    gphysdata[i,j] = rmiss
	  else
	    gphysdata[i,j] = gphys[i,j,index].val[0]
	  end
	end
      end
    end

    sagyou.put(gphysdata, "start"=>array1, "end"=>array2)
    time.put(times, "index"=>[index])
    array1.delete_at(-1)
    array2.delete_at(-1)
    index = index + 1
  end

  sagyoufile.close
  gphysrmiss = GPhys::IO.open("sagyou.nc",gphys.name)
  return gphysrmiss
end
def add_rmiss_and_nan_to_rmiss(gphys, rmiss)
  dimnum = gphys.rank
  sagyoufile = NetCDF.create('sagyou.nc')
  for num in 0..(dimnum - 1)
    dim = gphys.coord(num)
    sagyoufile.def_dim(dim.name, dim.length)
  end
  for num in 0..(dimnum-2)  #緯度, 経度, 高さまでの定義
    sagyoufile.redef
    dim = gphys.coord(num)
    sagyou = sagyoufile.def_var(dim.name, dim.ntype, [dim.name])
    for i in 0..(dim.att_names.size - 1)
      sagyou.put_att(dim.att_names[i], dim.get_att(dim.att_names[i]))
    end
    sagyoufile.enddef
    sagyou.put(dim.val)
  end
  sagyoufile.redef
  time = sagyoufile.def_var(gphys.coord(-1).name, gphys.coord(-1).ntype, [gphys.coord(-1).name])
  for i in 0..(gphys.coord(-1).att_names.size - 1)
    time.put_att(gphys.coord(-1).att_names[i], gphys.coord(-1).get_att(gphys.coord(-1).att_names[i]))
  end
  timecount = gphys.coord(-1).val
  sagyou = sagyoufile.def_var(gphys.name, gphys.ntype, gphys.axnames)
  for i in 0..(gphys.att_names.size - 1)
    sagyou.put_att(gphys.att_names[i], gphys.get_att(gphys.att_names[i]))
  end
  rmiss_narray=NArray.sfloat(1)
  rmiss_narray[0]=rmiss
  sagyou.put_att("missing_value",rmiss_narray)
  sagyoufile.enddef
  index=0
  time = sagyoufile.var(gphys.axnames[-1])
  axnames = gphys.shape.size - 1
  array1 = Array.new(axnames, 0)
  array2 = Array.new(axnames,0)
#  p gphys.shape
#  p dimnum
#  p rmiss
#  p gphys[0,0,-1,0].val[0].nan?
  timecount.each do |times|
    array1.fill(0,0..-1).push(index)
    array2.fill(-1,0..-1).push(index)
    #    p "test"
    if dimnum == 4 then
      gphysdata = NArray.sfloat(gphys.shape[0], gphys.shape[1], gphys.shape[2])
      #      p gphysdata
      for k in 0..(gphys.shape[2] - 1)
        for j in 0..(gphys.shape[1] - 1)
          for i in 0..(gphys.shape[0] - 1)
            #	    p "koti"
            #	    p gphys[i,j,k,index].val
            #	    p gphys[i,j,k,index].val[0].nan?
            if gphys[i,j,k,index].val[0].nan? then
              	      p times
              #	      p i
              #	      p j
              #	      p k
              gphysdata[i,j,k] = rmiss
            else
              #	      p times
              #	      p i
              #	      p j
              #	      p k
              gphysdata[i,j,k] = gphys[i,j,k,index].val[0]
            end
          end
        end
      end
    elsif dimnum == 3 then
      #      p gphysdata
      gphysdata = NArray.sfloat(gphys.shape[0], gphys.shape[1])
      for j in 0..(gphys.shape[1] - 1)
        for i in 0..(gphys.shape[0] - 1)
          if gphys[i,j,index].val[0].nan? then
            p times
            gphysdata[i,j] = rmiss
          else
            gphysdata[i,j] = gphys[i,j,index].val[0]
          end
        end
      end
    end

    sagyou.put(gphysdata, "start"=>array1, "end"=>array2)
    time.put(times, "index"=>[index])
    array1.delete_at(-1)
    array2.delete_at(-1)
    index = index + 1
  end

  sagyoufile.close
#  gphysrmiss = GPhys::IO.open("sagyou.nc",gphys.name)
#  return gphysrmiss
end
def global_mean_and_time_to_ls(gphys, rmiss)


  ls = GPhys::IO.open('../PlanetLonFromVE.nc',"PlanetLonFromVE")
#  ls = GPhys::IO.open(dir+'/'+"PlanetLonFromVE.nc","PlanetLonFromVE")
  lat = gphys.coord("lat")

  daysOfYear = 0
  DaysOfMonth.each do |i|
    daysOfYear += i
  end

  ts = (iyrs - 1) * daysOfYear * DataNumOfDay
  te = iyre * daysOfYear * DataNumOfDay
  days = daysOfYear*(iyre - iyrs + 1)
  p gphys.coord("time")[-1].val[0]
  p te
  if (gphys.coord("time")[-1].val[0]) < te then
    te = gphys.coord("time")[-1].val[0]
    days = (gphys.coord("time")[-1].val[0])/24
  end
  lscut = ls.cut("time"=>ts..te)
  ls = NArray.sfloat(days)

  p lscut.shape
  p days
  for i in 0..(days -1)
    ls[i] = lscut[(i * 24)..(i * 24 + 23)].mean(0).val
  end


  ls.length
  gphyscut = gphys.cut("time"=>ts..te) 

  p gphyscut.shape


  sagyoufile = NetCDF.create('sagyou.nc')
  gphyscut.axnames.each do |dim|
    if dim != "time" then
      sagyoufile.def_dim(dim, gphyscut.coord(dim).length)
    else
      sagyoufile.def_dim('Ls', ls.size)
    end
  end
  #軸定義
  gphyscut.axnames.each do |dim|
    sagyoufile.redef
    if dim != "time" then
      sagyou = sagyoufile.def_var(dim, gphyscut.coord(dim).ntype, [gphyscut.coord(dim).name])
      #属性定義
      for i in 0..gphyscut.coord(dim).att_names.size - 1
        sagyou.put_att(gphyscut.coord(dim).att_names[i], gphyscut.coord(dim).get_att(gphyscut.coord(dim).att_names[i]))
      end
      sagyoufile.enddef
      sagyou.put(gphyscut.coord(dim).val)
    else
      time = sagyoufile.def_var('Ls', lscut.ntype, ['Ls'])
      time.put_att(lscut.att_names[0], 'planetary longitude')
      for i in 1..lscut.att_names.size-1
        time.put_att(lscut.att_names[i], lscut.get_att(lscut.att_names[i]))
      end
      sagyoufile.enddef
    end
  end
  # 変数定義
  array = Array.new(gphyscut.shape.length)
  array = gphyscut.axnames
  array[-1] = 'Ls'
  sagyoufile.redef
  sagyou = sagyoufile.def_var(gphys.name, gphys.ntype, array)
  for i in 0..gphys.att_names.size-1
    sagyou.put_att(gphys.att_names[i], gphys.get_att(gphys.att_names[i]))
  end
  sagyoufile.enddef
  index = 0
  time = sagyoufile.var('Ls')
  p gphyscut.axnames.length
  array1 = Array.new(gphyscut.axnames.length - 1,0)
  array2 = Array.new(gphyscut.axnames.length - 1,0)
  ls.each do |times|
    array1.fill(0,0..-1).push(index)
    array2.fill(-1,0..-1).push(index)
    sagyou.put(gphyscut[false, (index * 24)..(index * 24 + 23)].mean(-1).val, "start"=>array1, "end"=>array2)
    time.put(times, "index"=>[index])
    array1.delete_at(-1)
    array2.delete_at(-1)
    index = index + 1
  end
  sagyoufile.close 
  gphystime = GPhys::IO.open("sagyou.nc", gphys.name)

  return gphystime


  dimnum = gphys.rank
  sagyoufile = NetCDF.create('sagyou.nc')
  for num in 0..(dimnum - 1)
    dim = gphys.coord(num)
    sagyoufile.def_dim(dim.name, dim.length)
  end
  for num in 0..(dimnum-2)  #緯度, 経度, 高さまでの定義
    sagyoufile.redef
    dim = gphys.coord(num)
    sagyou = sagyoufile.def_var(dim.name, dim.ntype, [dim.name])
    for i in 0..(dim.att_names.size - 1)
      sagyou.put_att(dim.att_names[i], dim.get_att(dim.att_names[i]))
    end
    sagyoufile.enddef
    sagyou.put(dim.val)
  end
  sagyoufile.redef
  time = sagyoufile.def_var(gphys.coord(-1).name, gphys.coord(-1).ntype, [gphys.coord(-1).name])
  for i in 0..(gphys.coord(-1).att_names.size - 1)
    time.put_att(gphys.coord(-1).att_names[i], gphys.coord(-1).get_att(gphys.coord(-1).att_names[i]))
  end
  timecount = gphys.coord(-1).val
  sagyou = sagyoufile.def_var(gphys.name, gphys.ntype, gphys.axnames)
  for i in 0..(gphys.att_names.size - 1)
    sagyou.put_att(gphys.att_names[i], gphys.get_att(gphys.att_names[i]))
  end
  rmiss_narray=NArray.sfloat(1)
  rmiss_narray[0]=rmiss
  sagyou.put_att("missing_value",rmiss_narray)
  sagyoufile.enddef
  index=0
  time = sagyoufile.var(gphys.axnames[-1])
  axnames = gphys.shape.size - 1
  array1 = Array.new(axnames, 0)
  array2 = Array.new(axnames,0)
#  p gphys.shape
#  p dimnum
#  p rmiss
#  p gphys[0,0,-1,0].val[0].nan?
  timecount.each do |times|
    array1.fill(0,0..-1).push(index)
    array2.fill(-1,0..-1).push(index)
    #    p "test"
    if dimnum == 4 then
      gphysdata = NArray.sfloat(gphys.shape[0], gphys.shape[1], gphys.shape[2])
      #      p gphysdata
      for k in 0..(gphys.shape[2] - 1)
        for j in 0..(gphys.shape[1] - 1)
          for i in 0..(gphys.shape[0] - 1)
            #	    p "koti"
            #	    p gphys[i,j,k,index].val
            #	    p gphys[i,j,k,index].val[0].nan?
            if gphys[i,j,k,index].val[0].nan? then
              	      p times
              #	      p i
              #	      p j
              #	      p k
              gphysdata[i,j,k] = rmiss
            else
              #	      p times
              #	      p i
              #	      p j
              #	      p k
              gphysdata[i,j,k] = gphys[i,j,k,index].val[0]
            end
          end
        end
      end
    elsif dimnum == 3 then
      #      p gphysdata
      gphysdata = NArray.sfloat(gphys.shape[0], gphys.shape[1])
      for j in 0..(gphys.shape[1] - 1)
        for i in 0..(gphys.shape[0] - 1)
          if gphys[i,j,index].val[0].nan? then
            p times
            gphysdata[i,j] = rmiss
          else
            gphysdata[i,j] = gphys[i,j,index].val[0]
          end
        end
      end
    end

    sagyou.put(gphysdata, "start"=>array1, "end"=>array2)
    time.put(times, "index"=>[index])
    array1.delete_at(-1)
    array2.delete_at(-1)
    index = index + 1
  end

  sagyoufile.close
#  gphysrmiss = GPhys::IO.open("sagyou.nc",gphys.name)
#  return gphysrmiss
end

#########################################################################################

def make_msf( gphys, namelat, namelev)

  rmiss = gphys.get_att('missing_value')[0]

  #z = gphys.axis(namelev).pos.convert_units(Units['Pa'])
  #z.long_name = 'pressure'
  #gphys.axis(namelev).set_pos(z)
  km = gphys.shape[2]
  lat = gphys.coord(namelat).val
  level = gphys.coord(namelev).val
  lon = gphys.shape[0]
  #gphyscopied = gphys.copy

  #z = gphyscopied.axis(namelev).pos.convert_units( Units['Pa'] )
  #z.long_name = 'pressure'
  #gphyscopied.axis(namelev).set_pos(z)

  #km    = gphyscopied.shape[2]
  #lat   = gphyscopied.coord(namelat).val
  #level = gphyscopied.coord(namelev).val
  #lon   = gphyscopied.shape[0]

  #gphysout = gphyscopied.copy


  #mask                  = gphyscopied.ne(rmiss)
  #gphyscopied[mask.not] = 0.0

  #mask        = gphyscopied.val.valid?
  #mask        = gphyscopied.val.get_mask
  #gphyscopied = gphyscopied.val.set_missing_value(0.0).all_valid
  #gphysout.long_name = 'mass stream function'
  #gphysout.units     = '1e8 kg/s'

  sagyoufile = NetCDF.create('../MSF.nc')
  gphys.axnames.each do |dim|
      sagyoufile.def_dim(dim, gphys.coord(dim).length)
  end
  #軸定義
  for num in 0..2  #緯度, 経度, 高さまでの定義
    sagyoufile.redef
    dim = gphys.coord(num)
    sagyou = sagyoufile.def_var(dim.name, dim.ntype, [dim.name])
    for i in 0..(dim.att_names.size - 1)
      sagyou.put_att(dim.att_names[i], dim.get_att(dim.att_names[i]))
    end
    sagyoufile.enddef
    sagyou.put(dim.val)
  end
  sagyoufile.redef
  time = sagyoufile.def_var(gphys.coord(-1).name, gphys.coord(-1).ntype, [gphys.coord(-1).name])
  for i in 0..(gphys.coord(-1).att_names.size - 1)
    time.put_att(gphys.coord(-1).att_names[i], gphys.coord(-1).get_att(gphys.coord(-1).att_names[i]))
  end
  timecount = gphys.coord(-1).val
  sagyou = sagyoufile.def_var("MSF", gphys.ntype, gphys.axnames)
  sagyou.put_att("long_name",'mass stream function')
  sagyou.put_att("units",'1e8 kg/s')
  sagyou.put_att("missing_value",rmiss)
  #for i in 0..(gphys.att_names.size - 1)
  #  sagyou.put_att(gphys.att_names[i], gphys.get_att(gphys.att_names[i]))
  #end
  sagyoufile.enddef
  index=0
  time = sagyoufile.var(gphys.axnames[-1])
  axnames = gphys.shape.size - 1
  array1 = Array.new(axnames, 0)
  array2 = Array.new(axnames,0)
  timecount.each do |times|
    gphyscopied = gphys.cut("time"=>times).copy
    gphysout = gphyscopied.copy
    mask = gphyscopied.ne(rmiss)
    gphyscopied[mask.not] = 0.0

    mask  = gphyscopied.val.get_mask
    gphyscopied = gphyscopied.val.set_missing_value(0.0).all_valid
    for i in 0..(lon -1)
      if level[0] > level[1] then
        gphysout[i,true,km-1] = (gphyscopied[i,true,km-1]) * level[km-1] / Grav * 2 * PI * RPlanet * cos( lat[true] * PI / 180.0 )
        k = km-1-1
        while k >= 0
          gphysout[i,true,k] = gphysout[i,true,k+1] + ( gphyscopied[i,true,k] + gphyscopied[i,true,k+1] ) * 0.5 * ( level[k] - level[k+1] ) / Grav * 2 * PI * RPlanet * cos( lat[true] * PI / 180.0 )
          k -= 1
        end
      elsif
        gphysout[i,true,0] = gphyscopied[i,true,0] * level[0] / Grav * 2 * PI * RPlanet * cos( lat[true] * PI / 180.0 )
        k = 0+1
        while k < km
          gphysout[i,true,k] = gphysout[i,true,k-1] + ( gphyscopied[i,true,k] + gphyscopied[i,true,k-1] ) * 0.5 * ( level[k] - level[k-1] ) / Grav * 2 * PI * RPlanet * cos( lat[true] * PI / 180.0 )
          k += 1
        end
      end
    end
    gphysoutNaMiss = gphysout.val.set_mask(mask)
    gphysout[true,true,true] = gphysoutNaMiss[true,true,true]
    gphysout = gphysout * 1.0e-8
    array1.fill(0,0..-1).push(index)
    array2.fill(-1,0..-1).push(index)
    sagyou.put(gphysout.val, "start"=>array1, "end"=>array2)
    time.put(times, "index"=>[index])
    array1.delete_at(-1)
    array2.delete_at(-1)
    index = index + 1
  end

  sagyoufile.close
end
