﻿#ver1.0
#2012/11/22 x-tを追加
#2012/11/29 x-tを変更月ごとの図にすることにする
#2012/12/10 lt の3d版追加, x-tを一日平均せず時間ごとの図にする
#2012/12/11 dcpam_time_divid を追加
#2012/12/18 Ls のロングネームを変更する
#2013/01/06 Ls表示にするルーチンでなぜかcut("Ls"=>180)Ls=180以下が全て"Ls"=>0になってしまうので対処として90だけ直接書いた
require 'gphys_const_v1.1'
require "numru/ggraph"
include NumRu
include NMath

#########################################################################################
def maketime ( dir, iyrs, iyre, gphys )

  ls = GPhys::IO.open(dir+'/'+"PlanetLonFromVE.nc","PlanetLonFromVE")
  lat = gphys.coord("lat")

  daysOfYear = 0
  DaysOfMonth.each do |i|
    daysOfYear += i
  end

  ts = (iyrs - 1) * daysOfYear * DataNumOfDay
  te = iyre * daysOfYear * DataNumOfDay
  lscut = ls.cut("time"=>ts..te)
  ls = NArray.sfloat(daysOfYear)

  for i in 0..daysOfYear*(iyre - iyrs + 1) - 1
    ls[i] = lscut[(i * 24)..(i * 24 +23)].mean(0).val
  end
   

 gphyscut = gphys.cut("time"=>ts..te) 
 

  sagyoufile = NetCDF.create('sagyou.nc')
  sagyoufile.def_dim(lat.name, lat.length)
  sagyoufile.def_dim('Ls', ls.size)
  #軸定義
  sagyou = sagyoufile.def_var(lat.name, lat.ntype, [lat.name])
  #属性定義
  for i in 0..lat.att_names.size - 1
    sagyou.put_att(lat.att_names[i], lat.get_att(lat.att_names[i]))
  end
  sagyoufile.enddef
  sagyou.put(lat.val)
  sagyoufile.redef
  time = sagyoufile.def_var('Ls', lscut.ntype, ['Ls'])
  time.put_att(lscut.att_names[0], 'planetary longitude')
  for i in 1..lscut.att_names.size-1
    time.put_att(lscut.att_names[i], lscut.get_att(lscut.att_names[i]))
  end
  # 変数定義
  sagyou =  sagyoufile.def_var(gphys.name, gphys.ntype,[lat.name,'Ls'])
  for i in 0..gphys.att_names.size-1
   sagyou.put_att(gphys.att_names[i], gphys.get_att(gphys.att_names[i]))
  end
  sagyoufile.enddef
  index = 0
  ls.each do |times|
    sagyou.put(gphyscut.mean(0)[false, (index * 24)..(index * 24 + 23)].mean(-1).val, "start"=>[0,index], "end"=>[-1,index])
    time.put(times, "index"=>[index])
    index = index + 1
  end
  sagyoufile.close 
  gphystime = GPhys::IO.open("sagyou.nc", gphys.name)

  return gphystime
end

######################################################################
########

def dcpam_hours(iyrs, iyre, lt)
#月の初めの時間を要素1に月の終わりの時間を要素2に入れる(それぞれの要素は入力ltの配列であらわされる)
  daysOfYear = 0
  DaysOfMonth.each do |i|
    daysOfYear += i
  end

  tsyear = (iyrs - 1) * daysOfYear * DataNumOfDay
  ts = Array.new(lt.size,tsyear)
  te = Array.new(lt.size,tsyear + DaysOfMonth[0] * DataNumOfDay)
  for i in 0..lt.size-1
     for mon in 0..(lt[i] - 2)
       if lt[i] - 2 <= 0 then
         ts[i] = 0
       else
         ts[i] = ts[i] + DaysOfMonth[mon] * DataNumOfDay
       end
       te[i] = te[i] + DaysOfMonth[mon+1] * DataNumOfDay
     end
  end
  hours = [ts,te]
  return hours
end

def dcpam_time_divid(iyrs, iyre, divid, lt)
#月ごとの時間をdividの要素に合わせてわけた配列を返す
  hours = dcpam_hours(iyrs, iyre, lt)
  divsize = Array.new(lt.length)
  for imon in 0..(lt.length - 1)
    tmp1 = (hours[1][imon] - hours[0][imon] + divid[0] + 1).divmod(divid[1])
    if tmp1[1] == 0 then
      tmp2 = Array.new(tmp1[0]+1)
      tmp2[0] = hours[0][imon] + divid[0]
      for div in 1..(tmp2.length - 1)
        tmp2[div] = tmp2[div - 1] + divid[1] - 1
      end  
    else
      tmp2 = Array.new(tmp1[0] + 2)
      tmp2[0] = hours[0][imon] + divid[0]
      for div in 1..(tmp2.length - 1)
        tmp2[div] = tmp2[div - 1] + divid[1] - 1
      end
      tmp2[-1] = hours[1][imon]
    end
    divsize[imon] = tmp2
  end
  return divsize
end

def dcpam_lt( hour, gphys)

  gphyscut = gphys.cut("time"=>hour)
  return gphyscut
end

def dcpam_lt3d( hour, lev, gphys)

  gphyscut = gphys.cut("time"=>hour, "level"=>lev)
  return gphyscut
end

def dcpam_x_t2d ( dir, hourss, hourse, iyrs, iyre, lat, gphys )

  ls = GPhys::IO.open(dir+'/'+"PlanetLonFromVE.nc","PlanetLonFromVE")
  lon = gphys.coord("lon")

  lscut = ls.cut("time"=>hourss..hourse)

 gphyscut = gphys.cut("lat"=>lat,"time"=>hourss..hourse) 

  sagyoufile = NetCDF.create('sagyou.nc')
  sagyoufile.def_dim(lon.name, lon.length)
  sagyoufile.def_dim('Ls', lscut.length)
  #軸定義
  sagyou = sagyoufile.def_var(lon.name, lon.ntype, [lon.name])
  #属性定義
  for i in 0..lon.att_names.size - 1
    sagyou.put_att(lon.att_names[i], lon.get_att(lon.att_names[i]))
  end
  sagyoufile.enddef
  sagyou.put(lon.val)
  sagyoufile.redef
  time = sagyoufile.def_var('Ls', lscut.ntype, ['Ls'])
  time.put_att(lscut.att_names[0], 'planetary longitude')
  for i in 1..lscut.att_names.size-1
    time.put_att(lscut.att_names[i], lscut.get_att(lscut.att_names[i]))
  end
  # 変数定義
  sagyou =  sagyoufile.def_var(gphys.name, gphys.ntype,[lon.name,'Ls'])
  for i in 0..gphys.att_names.size-1
   sagyou.put_att(gphys.att_names[i], gphys.get_att(gphys.att_names[i]))
  end
  sagyoufile.enddef
  index = 0
  lscut.val.each do |times|
    sagyou.put(gphyscut[false, index].val, "start"=>[0,index], "end"=>[-1,index])
    time.put(times, "index"=>[index])
    index = index + 1
  end
  sagyoufile.close 
  gphysxt = GPhys::IO.open("sagyou.nc", gphys.name)

  return gphysxt
end
def dcpam_x_t3d ( dir, hourss, hourse, iyrs, iyre, lat, alt, gphys )

  ls = GPhys::IO.open(dir+'/'+"PlanetLonFromVE.nc","PlanetLonFromVE")
  lon = gphys.coord("lon")

  lscut = ls.cut("time"=>hourss..hourse)

 gphyscut = gphys.cut("lat"=>lat, "level"=>alt, "time"=>hourss..hourse) 
 

  sagyoufile = NetCDF.create('sagyou.nc')
  sagyoufile.def_dim(lon.name, lon.length)
  sagyoufile.def_dim('Ls', lscut.length)
  #軸定義
  sagyou = sagyoufile.def_var(lon.name, lon.ntype, [lon.name])
  #属性定義
  for i in 0..lon.att_names.size - 1
    sagyou.put_att(lon.att_names[i], lon.get_att(lon.att_names[i]))
  end
  sagyoufile.enddef
  sagyou.put(lon.val)
  sagyoufile.redef
  time = sagyoufile.def_var('Ls', lscut.ntype, ['Ls'])
  time.put_att(lscut.att_names[0], 'planetary longitude')
  for i in 1..lscut.att_names.size-1
    time.put_att(lscut.att_names[i], lscut.get_att(lscut.att_names[i]))
  end
  # 変数定義
  sagyou =  sagyoufile.def_var(gphys.name, gphys.ntype,[lon.name,'Ls'])
  for i in 0..gphys.att_names.size-1
   sagyou.put_att(gphys.att_names[i], gphys.get_att(gphys.att_names[i]))
  end
  sagyoufile.enddef
  index = 0
  lscut.val.each do |times|
    sagyou.put(gphyscut[false,index].val, "start"=>[0,index], "end"=>[-1,index])
    time.put(times, "index"=>[index])
    index = index + 1
  end
  sagyoufile.close 
  gphysxt = GPhys::IO.open("sagyou.nc", gphys.name)

  return gphysxt
end

def dcpam_x_t2d_daymean ( dir, hourss, hourse, iyrs, iyre, lat, gphys )

  ls = GPhys::IO.open(dir+'/'+"PlanetLonFromVE.nc","PlanetLonFromVE")
  lon = gphys.coord("lon")

  daysOfYear = 0
  DaysOfMonth.each do |i|
    daysOfYear += i
  end
  dayss = 0
  for days in 0..hourss-2 
    dayss += DaysOfMonth[days]
  end
  dayse = 0
  for days in 0..hourse-1
    dayse += DaysOfMonth[days]
  end
  ts = (iyrs - 1) * daysOfYear * DataNumOfDay + dayss * DataNumOfDay
  te = iyre * daysOfYear * DataNumOfDay + dayse * DataNumOfDay
  lscut = ls.cut("time"=>ts..te)
  ls = NArray.sfloat(dayse - dayss)

  for i in 0..(dayse - dayss - 1)
    ls[i] = lscut[(i * 24)..(i * 24 +23)].mean(0).val
  end
   

 gphyscut = gphys.cut("lat"=>lat,"time"=>ts..te) 
 

  sagyoufile = NetCDF.create('sagyou.nc')
  sagyoufile.def_dim(lon.name, lon.length)
  sagyoufile.def_dim('Ls', ls.size)
  #軸定義
  sagyou = sagyoufile.def_var(lon.name, lon.ntype, [lon.name])
  #属性定義
  for i in 0..lon.att_names.size - 1
    sagyou.put_att(lon.att_names[i], lon.get_att(lon.att_names[i]))
  end
  sagyoufile.enddef
  sagyou.put(lon.val)
  sagyoufile.redef
  time = sagyoufile.def_var('Ls', lscut.ntype, ['Ls'])
  time.put_att(lscut.att_names[0], 'planetary longitude')
  for i in 1..lscut.att_names.size-1
    time.put_att(lscut.att_names[i], lscut.get_att(lscut.att_names[i]))
  end
  # 変数定義
  sagyou =  sagyoufile.def_var(gphys.name, gphys.ntype,[lon.name,'Ls'])
  for i in 0..gphys.att_names.size-1
   sagyou.put_att(gphys.att_names[i], gphys.get_att(gphys.att_names[i]))
  end
  sagyoufile.enddef
  index = 0
  ls.each do |times|
    sagyou.put(gphyscut[false, (index * 24)..(index * 24 + 23)].mean(-1).val, "start"=>[0,index], "end"=>[-1,index])
    time.put(times, "index"=>[index])
    index = index + 1
  end
  sagyoufile.close 
  gphysxt = GPhys::IO.open("sagyou.nc", gphys.name)

  return gphysxt
end
def dcpam_x_t3d_daymean ( dir, hourss, hourse, iyrs, iyre, lat, alt, gphys )

  ls = GPhys::IO.open(dir+'/'+"PlanetLonFromVE.nc","PlanetLonFromVE")
  lon = gphys.coord("lon")

  daysOfYear = 0
  DaysOfMonth.each do |i|
    daysOfYear += i
  end

  dayss = 0
  for days in 0..hourss-2 
    dayss += DaysOfMonth[days]
  end
  dayse = 0
  for days in 0..hourse-1
    dayse += DaysOfMonth[days]
  end
  ts = (iyrs - 1) * daysOfYear * DataNumOfDay + dayss * DataNumOfDay
  te = iyre * daysOfYear * DataNumOfDay + dayse * DataNumOfDay
  lscut = ls.cut("time"=>ts..te)
  ls = NArray.sfloat(dayse - dayss)

  for i in 0..(dayse - dayss - 1)
    ls[i] = lscut[(i * 24)..(i * 24 +23)].mean(0).val
  end

 gphyscut = gphys.cut("lat"=>lat, "level"=>alt, "time"=>ts..te) 
 

  sagyoufile = NetCDF.create('sagyou.nc')
  sagyoufile.def_dim(lon.name, lon.length)
  sagyoufile.def_dim('Ls', ls.size)
  #軸定義
  sagyou = sagyoufile.def_var(lon.name, lon.ntype, [lon.name])
  #属性定義
  for i in 0..lon.att_names.size - 1
    sagyou.put_att(lon.att_names[i], lon.get_att(lon.att_names[i]))
  end
  sagyoufile.enddef
  sagyou.put(lon.val)
  sagyoufile.redef
  time = sagyoufile.def_var('Ls', lscut.ntype, ['Ls'])
  time.put_att(lscut.att_names[0], 'planetary longitude')
  for i in 1..lscut.att_names.size-1
    time.put_att(lscut.att_names[i], lscut.get_att(lscut.att_names[i]))
  end
  # 変数定義
  sagyou =  sagyoufile.def_var(gphys.name, gphys.ntype,[lon.name,'Ls'])
  for i in 0..gphys.att_names.size-1
   sagyou.put_att(gphys.att_names[i], gphys.get_att(gphys.att_names[i]))
  end
  sagyoufile.enddef
  index = 0
  ls.each do |times|
    sagyou.put(gphyscut[false, (index * 24)..(index * 24 + 23)].mean(-1).val, "start"=>[0,index], "end"=>[-1,index])
    time.put(times, "index"=>[index])
    index = index + 1
  end
  sagyoufile.close 
  gphysxt = GPhys::IO.open("sagyou.nc", gphys.name)

  return gphysxt
end

def dcpam_SurfMaj ( dir, iyrs, iyre ) 
  ls = GPhys::IO.open(dir+'/'+"PlanetLonFromVE.nc","PlanetLonFromVE")

  daysOfYear = 0
  DaysOfMonth.each do |i|
    daysOfYear += i
  end

  ts = (iyrs - 1) * daysOfYear * DataNumOfDay
  te = iyre * daysOfYear * DataNumOfDay

  lscut = ls.cut("time"=>ts..te)

  gphys = GPhys::IO.open(dir+'/'+'SurfMajCompIce.nc','SurfMajCompIce')
  gphyscut = gphys.cut("time"=>ts..te) 

  sagyoufile = NetCDF.create('sagyou2.nc')
  for i in 0..gphys.shape.size-2
    sagyoufile.def_dim(gphys.coord(i).name, gphys.coord(i).length)
  end
  sagyoufile.def_dim('Ls', lscut.length)
  #軸定義
  for i in 0..gphys.shape.size-2
    sagyou = sagyoufile.def_var(gphys.coord(i).name, gphys.coord(i).ntype, [gphys.coord(i).name])
  #属性定義
    for j in 0..gphys.coord(i).att_names.size - 1
      sagyou.put_att(gphys.coord(i).att_names[j], gphys.coord(i).get_att(gphys.coord(i).att_names[j]))
    end
    sagyoufile.enddef
    sagyou.put(gphys.coord(i).val)
    sagyoufile.redef
  end
  time = sagyoufile.def_var('Ls', lscut.ntype, ['Ls'])
  time.put_att(lscut.att_names[0], 'planetary longitude')
  for i in 1..lscut.att_names.size-1
    time.put_att(lscut.att_names[i], lscut.get_att(lscut.att_names[i]))
  end
  # 変数定義
  array = Array.new(gphys.shape.size)
  for i in 0..array.size-2
    array[i] = gphys.coord(i).name
  end
  array[-1] = 'Ls'
  sagyou =  sagyoufile.def_var(gphys.name, gphys.ntype, array)
  for i in 0..gphys.att_names.size-1
   sagyou.put_att(gphys.att_names[i], gphys.get_att(gphys.att_names[i]))
  end
  sagyoufile.enddef
  index = 0
  array1 = Array.new(gphys.shape.size-1,0)
  array2 = Array.new(gphys.shape.size-1,0)
  lscut.val.each do |times|
    array1.fill(0,0..gphys.shape.size-2).push(index)
    array2.fill(-1,0..gphys.shape.size-2).push(index)
    sagyou.put(gphyscut[false,index].val, "start"=>array1, "end"=>array2)
    time.put(times, "index"=>[index])
    array1.delete_at(-1)
    array2.delete_at(-1)
    index = index + 1
  end
  sagyoufile.close
end

def dcpam_ls ( dir, iyrs, iyre, gphys ) 
  ls = GPhys::IO.open(dir+'/'+"PlanetLonFromVE.nc","PlanetLonFromVE")

  daysOfYear = 0
  DaysOfMonth.each do |i|
    daysOfYear += i
  end

  ts = (iyrs - 1) * daysOfYear * DataNumOfDay
  te = iyre * daysOfYear * DataNumOfDay

  lscut = ls.cut("time"=>ts..te)

  gphyscut = gphys.cut("time"=>ts..te) 

  sagyoufile = NetCDF.create('sagyou.nc')
  for i in 0..gphys.shape.size-2
    sagyoufile.def_dim(gphys.coord(i).name, gphys.coord(i).length)
  end
  sagyoufile.def_dim('Ls', lscut.length)
  #軸定義
  for i in 0..gphys.shape.size-2
    sagyou = sagyoufile.def_var(gphys.coord(i).name, gphys.coord(i).ntype, [gphys.coord(i).name])
  #属性定義
    for j in 0..gphys.coord(i).att_names.size - 1
      sagyou.put_att(gphys.coord(i).att_names[j], gphys.coord(i).get_att(gphys.coord(i).att_names[j]))
    end
    sagyoufile.enddef
    sagyou.put(gphys.coord(i).val)
    sagyoufile.redef
  end
  time = sagyoufile.def_var('Ls', lscut.ntype, ['Ls'])
  time.put_att(lscut.att_names[0], 'planetary longitude')
  for i in 1..lscut.att_names.size-1
    time.put_att(lscut.att_names[i], lscut.get_att(lscut.att_names[i]))
  end
  # 変数定義
  array = Array.new(gphys.shape.size)
  for i in 0..array.size-2
    array[i] = gphys.coord(i).name
  end
  array[-1] = 'Ls'
  sagyou =  sagyoufile.def_var(gphys.name, gphys.ntype, array)
  for i in 0..gphys.att_names.size-1
   sagyou.put_att(gphys.att_names[i], gphys.get_att(gphys.att_names[i]))
  end
  sagyoufile.enddef
  index = 0
  array1 = Array.new(gphys.shape.size-1,0)
  array2 = Array.new(gphys.shape.size-1,0)
  lscut.val.each do |times|
    array1.fill(0,0..gphys.shape.size-2).push(index)
    array2.fill(-1,0..gphys.shape.size-2).push(index)
    sagyou.put(gphyscut[false,index].val, "start"=>array1, "end"=>array2)
    time.put(times, "index"=>[index])
    array1.delete_at(-1)
    array2.delete_at(-1)
    index = index + 1
  end
  sagyoufile.close
end

def dcpam_ls3d ( dir, iyrs, iyre, lstime, gphys ) 
  ls = GPhys::IO.open(dir+'/'+"PlanetLonFromVE.nc","PlanetLonFromVE")

  daysOfYear = 0
  DaysOfMonth.each do |i|
    daysOfYear += i
  end

  ts = (iyrs - 1) * daysOfYear * DataNumOfDay
  te = iyre * daysOfYear * DataNumOfDay

  lscut = ls.cut("time"=>ts..te)

  gphyscut = gphys.cut("time"=>ts..te) 
 

  sagyoufile = NetCDF.create('sagyou.nc')
  for i in 0..gphys.shape.size-2
    sagyoufile.def_dim(gphys.coord(i).name, gphys.coord(i).length)
  end
  sagyoufile.def_dim('Ls', lscut.length)
  #軸定義
  for i in 0..gphys.shape.size-2
    sagyou = sagyoufile.def_var(gphys.coord(i).name, gphys.coord(i).ntype, [gphys.coord(i).name])
  #属性定義
    for j in 0..gphys.coord(i).att_names.size - 1
      sagyou.put_att(gphys.coord(i).att_names[j], gphys.coord(i).get_att(gphys.coord(i).att_names[j]))
    end
    sagyoufile.enddef
    sagyou.put(gphys.coord(i).val)
    sagyoufile.redef
  end
  time = sagyoufile.def_var('Ls', lscut.ntype, ['Ls'])
  time.put_att(lscut.att_names[0], 'planetary longitude')
  for i in 1..lscut.att_names.size-1
    time.put_att(lscut.att_names[i], lscut.get_att(lscut.att_names[i]))
  end
  # 変数定義
  array = Array.new(gphys.shape.size)
  for i in 0..array.size-2
    array[i] = gphys.coord(i).name
  end
  array[-1] = 'Ls'
  sagyou =  sagyoufile.def_var(gphys.name, gphys.ntype, array)
  for i in 0..gphys.att_names.size-1
   sagyou.put_att(gphys.att_names[i], gphys.get_att(gphys.att_names[i]))
  end
  sagyoufile.enddef
  index = 0
  array1 = Array.new(gphys.shape.size-1,0)
  array2 = Array.new(gphys.shape.size-1,0)
  lscut.val.each do |times|
    array1.fill(0,0..gphys.shape.size-2).push(index)
    array2.fill(-1,0..gphys.shape.size-2).push(index)
    sagyou.put(gphyscut[false,index].val, "start"=>array1, "end"=>array2)
    time.put(times, "index"=>[index])
    array1.delete_at(-1)
    array2.delete_at(-1)
    index = index + 1
  end
  sagyoufile.close
 
  gphysls = GPhys::IO.open("sagyou.nc", gphys.name)
  if lstime == 90 then
    gphyslscut = gphysls[false,4642]
  else 
    gphyslscut = gphysls.cut("Ls"=>lstime)
  end
  return gphyslscut
end
def dcpam_z_t3d ( dir, hourss, hourse, iyrs, iyre, lat, lonswitch, lon, gphys )

  ls = GPhys::IO.open('../'+"PlanetLonFromVE.nc","PlanetLonFromVE")

  lscut = ls.cut("time"=>hourss..hourse)

  if lonswitch then
   gphyscut = gphys.cut("lat"=>lat, "time"=>hourss..hourse).mean(0)
  else
   gphyscut = gphys.cut("lat"=>lon, "lat"=>lat, "time"=>hourss..hourse)
  end

  sagyoufile = NetCDF.create('sagyou.nc')
  sagyoufile.def_dim(gphys.coord("level").name, gphys.coord("level").length)
  sagyoufile.def_dim('Ls', lscut.length)
  #軸定義
  sagyou = sagyoufile.def_var(gphys.coord("level").name, gphys.coord("level").ntype, [gphys.coord("level").name])
  #属性定義
  for i in 0..gphys.coord("level").att_names.size - 1
    sagyou.put_att(gphys.coord("level").att_names[i], gphys.coord("level").get_att(gphys.coord("level").att_names[i]))
  end
  sagyoufile.enddef
  sagyou.put(gphys.coord("level").val)
  sagyoufile.redef
  time = sagyoufile.def_var('Ls', lscut.ntype, ['Ls'])
  time.put_att(lscut.att_names[0], 'planetary longitude')
  for i in 1..lscut.att_names.size-1
    time.put_att(lscut.att_names[i], lscut.get_att(lscut.att_names[i]))
  end
  # 変数定義
  sagyou =  sagyoufile.def_var(gphys.name, gphys.ntype,[gphys.coord("level").name,'Ls'])
  for i in 0..gphys.att_names.size-1
   sagyou.put_att(gphys.att_names[i], gphys.get_att(gphys.att_names[i]))
  end
  sagyoufile.enddef
  index = 0
  lscut.val.each do |times|
    sagyou.put(gphyscut[false,index].val, "start"=>[0,index], "end"=>[-1,index])
    time.put(times, "index"=>[index])
    index = index + 1
  end
  sagyoufile.close 
  gphysxt = GPhys::IO.open("sagyou.nc", gphys.name)

  return gphysxt
end
def time_dis(iyrs, iyre, divid, lt)
#月ごとの時間をdividの要素に合わせてわけた配列を返す
  hours = dcpam_hours(iyrs, iyre, lt)
  divsize = Array.new(lt.length)
  for imon in 0..(lt.length - 1)
    tmp1 = (hours[1][imon] - hours[0][imon] + divid[0] + 1).divmod(divid[1])
    tmp2 = Array.new(tmp1[0]+1)
    tmp2[0] = hours[0][imon] + divid[0]
    for div in 1..(tmp2.length - 1)
      tmp2[div] = tmp2[div - 1] + divid[1] - 1
    end  
    divsize[imon] = tmp2
#    divsize[imon,1] = tmp1[0]
  end
  return divsize
end
def dcpam_time_num(hourss, hourse, lat, lon, pat, timenum, gphys)
     localt=(lon-180)/15
     hourss = hourss + localt
     hourse = hourse + localt
  gphyscut = gphys.cut("lon"=>lon, "lat"=>lat, "time"=>hourss..hourse)
 for time in 0..24
   if gphyscut[false, time].val[0] >= pat then
      timenum[time] += 1
   end
 end  
 return timenum
end
