# -*- coding: utf-8 -*-
#
# gphys に関係しないテクニック的なスクリプトをまとめる
# 2015/08/07 v1 作成. add_slash を追加 
# 2015/08/25 makeanim.rb を移す
# 2015/09/09 ext_time を追加. v2
# 2015/10/22 荻原 hour_to_lon を作成 ver2
#                 lon_to_index を作成 ver2
#
$LOAD_PATH.push(Dir.pwd)
require 'rubygems'
require 'rmagick'

include Magick

########################################################################################
def add_slash(dir)
  #ディレクトリを指定した時に最後に/を入れても入れなくても最後に / を追加する
  hantei = dir.slice(dir.length-1, dir.length-1)
  if hantei != "/" then
    dir << "/"
  end
  return dir
end


def make_anime(animefig, delay, animefile)
  #gifアニメ作成スクリプト 

  images = ImageList.new()
  animefig.each_with_index do |fig, index|
    images[index] = Image.read(fig)[0]
  end
  #  images.iterations = 1#0にすると無限回繰り返す
  images.iterations = 0
  images.each do |img|
    img.delay = delay
  end
  images.write(animefile)

end

def ext_time(iyrs, iyre, vir_sp_dir, sp_file, sp_vname, vir_dir, file, vname)
  # sp_for_Mars_T021_MGS.nc から指定された var (topog, albed, tiのどれか) 緯度, 経度の値は同じで時間に拡張したファイルを作成する.一度 time.nc を作成した場合は作成しない. 
  # ls_array は指定する Ls の配列. 指定したい Ls の数だけ配列に加えて返す 
  # 複数年またぐ場合はバグる可能性が高いので注意.
  sp_dir = vir_sp_dir.dup
  dir = vir_dir.dup
  sp_dir = add_slash(sp_dir)
  dir = add_slash(dir)
  var = GPhys::IO.open(sp_dir+sp_file+".nc",sp_vname)

  vir = GPhys::IO.open(dir+file+".nc",vname)
  daysOfYear = 0
  DaysOfMonth.each do |i|
    daysOfYear += i
  end

  ts = (iyrs - 1) * daysOfYear * DataNumOfDay
  te = iyre * daysOfYear * DataNumOfDay
  days = daysOfYear*(iyre - iyrs + 1)
  if (vir.coord("time")[-1].val[0]) < te then
    te = vir.coord("time")[-1].val[0]
  end

  if File.exist?("./tmp/"+sp_file+"_ext_time.nc")
    time = GPhys::IO.open("./tmp/"+sp_file+"_ext_time.nc", "time")
    unless time.val[0] == ts && time.val[-1] == te
      time.close
      system('rm -f ./tmp/'+sp_file+'_ext_time.nc')
    end
  end
  unless File.exist?("./tmp/"+sp_file+"_ext_time.nc") 
    vircut = vir.cut("time"=>ts..te)
    time = NArray.sfloat(vircut.length)

    for i in 0..vircut.coord("time").length-1
      time[i] = vircut.coord("time").val[i]
    end

    sagyoufile = NetCDF.create("./tmp/"+sp_file+"_ext_time.nc")
    #sp_file_ext_time.nc の軸定義
    var.axnames.each do |dimname|
      unless dimname == 'time'
        dim = var.coord(dimname)
        sagyoufile.def_dim(dim.name, dim.length)
      end
    end
    sagyoufile.def_dim('time', vircut.length)
    # 時間軸以外の定義
    var.axnames.each do |dimname|
      unless dimname == 'time'
        sagyoufile.redef
        dim = var.coord(dimname)
        sagyou = sagyoufile.def_var(dim.name, dim.ntype, [dim.name])
        for i in 0..(dim.att_names.size - 1)
          sagyou.put_att(dim.att_names[i], dim.get_att(dim.att_names[i]))
        end
        sagyoufile.enddef
        sagyou.put(dim.val)
      end
    end
    sagyoufile.redef
    time_dim = sagyoufile.def_var(vir.coord(-1).name, vir.coord(-1).ntype, [vir.coord(-1).name])
    for i in 0..(vir.coord(-1).att_names.size - 1)
      time_dim.put_att(vir.coord(-1).att_names[i], vir.coord(-1).get_att(vir.coord(-1).att_names[i]))
    end
    timecount = vir.coord(-1).val
    var_axnames = var.axnames << vir.coord(-1).name
    sagyou = sagyoufile.def_var(var.name, var.ntype, var_axnames)
    for i in 0..(var.att_names.size - 1)
      sagyou.put_att(var.att_names[i], var.get_att(var.att_names[i]))
    end
    sagyoufile.enddef
    index=0
    time = sagyoufile.var(vir.axnames[-1])
    axnames = var.shape.size
    array1 = Array.new(axnames, 0)
    array2 = Array.new(axnames,0)
    timecount.each do |times|
      array1.fill(0,0..-1).push(index)
      array2.fill(-1,0..-1).push(index)

      sagyou.put(var.val, "start"=>array1, "end"=>array2)
      time.put(times, "index"=>[index])
      array1.delete_at(-1)
      array2.delete_at(-1)
      index = index + 1
    end
    sagyoufile.close
  end
end

def hour_to_lon(hour)
  # 経度 0 度が 0 時の時の引数 hour に合わせた経度を返す
  lon = hour * 15
  return lon
end

def lon_to_index(lon, gphys)
  # gphys データで与えられた lon が lon 軸の何番目の要素かを返す

  index_judgment = gphys.cut_rank_conserving("lon"=>lon).coord("lon").val[0]
  index = nil
  gphys.coord("lon").to_a.each_with_index do |lon, index_of_gphys|
    index = index_of_gphys if lon == index_judgment
  end
  return index
end

